<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>eRPC API Reference: erpc::Service Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eRPC API Reference
   &#160;<span id="projectnumber">Rev. 1.4.0</span>
   </div>
   <div id="projectbrief">NXP Semiconductors</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>API&#160;Reference</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classerpc_1_1_service.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classerpc_1_1_service-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">erpc::Service Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span><div class="ingroups"><a class="el" href="group__infra.html">Infrastructure</a> &raquo; <a class="el" href="group__infra__server.html">Server</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Abstract interface for service, which can be executed on server side.  
 <a href="classerpc_1_1_service.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="server_8h_source.html">server.h</a>&gt;</code></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Collaboration diagram for erpc::Service:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
<div class="center"><iframe scrolling="no" frameborder="0" src="classerpc_1_1_service__coll__graph.svg" width="180" height="38"><p><b>This browser is not able to show SVG: try Firefox, Chrome, Safari, or Opera instead.</b></p></iframe>
</div>
<center><span class="legend">[<a target="top" href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad434cc308d22167ae9ea98c109def16e"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_service.html#ad434cc308d22167ae9ea98c109def16e">Service</a> (uint32_t serviceId)</td></tr>
<tr class="memdesc:ad434cc308d22167ae9ea98c109def16e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#ad434cc308d22167ae9ea98c109def16e">More...</a><br /></td></tr>
<tr class="separator:ad434cc308d22167ae9ea98c109def16e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4fbd5171a6b29560d2ca3bf3aad3020b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4fbd5171a6b29560d2ca3bf3aad3020b"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_service.html#a4fbd5171a6b29560d2ca3bf3aad3020b">~Service</a> ()</td></tr>
<tr class="memdesc:a4fbd5171a6b29560d2ca3bf3aad3020b"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classerpc_1_1_service.html" title="Abstract interface for service, which can be executed on server side. ">Service</a> destructor. <br /></td></tr>
<tr class="separator:a4fbd5171a6b29560d2ca3bf3aad3020b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b3706517467b41930f851448369b4b3"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_service.html#a6b3706517467b41930f851448369b4b3">getServiceId</a> () const </td></tr>
<tr class="memdesc:a6b3706517467b41930f851448369b4b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return service id number.  <a href="#a6b3706517467b41930f851448369b4b3">More...</a><br /></td></tr>
<tr class="separator:a6b3706517467b41930f851448369b4b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acb1ffd32374c6ee56158178771190e5a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classerpc_1_1_service.html">Service</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_service.html#acb1ffd32374c6ee56158178771190e5a">getNext</a> ()</td></tr>
<tr class="memdesc:acb1ffd32374c6ee56158178771190e5a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return next service.  <a href="#acb1ffd32374c6ee56158178771190e5a">More...</a><br /></td></tr>
<tr class="separator:acb1ffd32374c6ee56158178771190e5a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac7f0e6b17b44fd8be07bcb92d0454360"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_service.html#ac7f0e6b17b44fd8be07bcb92d0454360">setNext</a> (<a class="el" href="classerpc_1_1_service.html">Service</a> *next)</td></tr>
<tr class="memdesc:ac7f0e6b17b44fd8be07bcb92d0454360"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set next service.  <a href="#ac7f0e6b17b44fd8be07bcb92d0454360">More...</a><br /></td></tr>
<tr class="separator:ac7f0e6b17b44fd8be07bcb92d0454360"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc0b3e350803e0388da9a01db2b99f5c"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__infra.html#ga5f8872e58f09a16d192bf664f9898651">erpc_status_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_service.html#abc0b3e350803e0388da9a01db2b99f5c">handleInvocation</a> (uint32_t methodId, uint32_t sequence, <a class="el" href="classerpc_1_1_codec.html">Codec</a> *codec, <a class="el" href="classerpc_1_1_message_buffer_factory.html">MessageBufferFactory</a> *messageFactory)=0</td></tr>
<tr class="memdesc:abc0b3e350803e0388da9a01db2b99f5c"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function call function implementation of current service.  <a href="#abc0b3e350803e0388da9a01db2b99f5c">More...</a><br /></td></tr>
<tr class="separator:abc0b3e350803e0388da9a01db2b99f5c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:ac700bb6ac87107300d3bf23bc68b7a5a"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_service.html#ac700bb6ac87107300d3bf23bc68b7a5a">m_serviceId</a></td></tr>
<tr class="separator:ac700bb6ac87107300d3bf23bc68b7a5a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aac1ddd21edb74c3c41c4808f28c59b32"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classerpc_1_1_service.html">Service</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_service.html#aac1ddd21edb74c3c41c4808f28c59b32">m_next</a></td></tr>
<tr class="separator:aac1ddd21edb74c3c41c4808f28c59b32"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Abstract interface for service, which can be executed on server side. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ad434cc308d22167ae9ea98c109def16e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">erpc::Service::Service </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>serviceId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Constructor. </p>
<p>This function initializes object attributes. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a6b3706517467b41930f851448369b4b3"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t erpc::Service::getServiceId </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return service id number. </p>
<dl class="section return"><dt>Returns</dt><dd><a class="el" href="classerpc_1_1_service.html" title="Abstract interface for service, which can be executed on server side. ">Service</a> id number. </dd></dl>

</div>
</div>
<a class="anchor" id="acb1ffd32374c6ee56158178771190e5a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classerpc_1_1_service.html">Service</a>* erpc::Service::getNext </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return next service. </p>
<dl class="section return"><dt>Returns</dt><dd>Pointer to next service. </dd></dl>

</div>
</div>
<a class="anchor" id="ac7f0e6b17b44fd8be07bcb92d0454360"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void erpc::Service::setNext </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classerpc_1_1_service.html">Service</a> *&#160;</td>
          <td class="paramname"><em>next</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set next service. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">next</td><td>Pointer to next service. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="abc0b3e350803e0388da9a01db2b99f5c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="group__infra.html#ga5f8872e58f09a16d192bf664f9898651">erpc_status_t</a> erpc::Service::handleInvocation </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>methodId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>sequence</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classerpc_1_1_codec.html">Codec</a> *&#160;</td>
          <td class="paramname"><em>codec</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classerpc_1_1_message_buffer_factory.html">MessageBufferFactory</a> *&#160;</td>
          <td class="paramname"><em>messageFactory</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This function call function implementation of current service. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">methodId</td><td>Id number of function, which is requested. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">sequence</td><td>Sequence number. To be sure that reply from server belongs to client request. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">codec</td><td>For reading and writing data. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">messageFactory</td><td>Used for setting output buffer.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Based on handleInvocation implementation. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="ac700bb6ac87107300d3bf23bc68b7a5a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t erpc::Service::m_serviceId</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p><a class="el" href="classerpc_1_1_service.html" title="Abstract interface for service, which can be executed on server side. ">Service</a> unique id. </p>

</div>
</div>
<a class="anchor" id="aac1ddd21edb74c3c41c4808f28c59b32"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classerpc_1_1_service.html">Service</a>* erpc::Service::m_next</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Pointer to next service. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="server_8h_source.html">server.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- HTML footer for doxygen 1.8.5-->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul class="foot">
    <li class="footer">&copy; 2016 NXP Semiconductors. All rights reserved.
    </li>
  </ul>
</div>
</body>
</html>
